#include <bits/stdc++.h>
using namespace std;
// #define int long long
#define i64 long long
inline int read(void) {
    int sgn=1,x=0; char c=getchar();
    while(c<'0'||c>'9') { (c=='-'&&(sgn=0)); c=getchar(); }
    while('0'<=c&&c<='9') x=x*10+c-'0',c=getchar();
    return sgn ? x : -x;
}
void write(int x) {
    if(x<0) putchar('-'),x=-x;
    if(x>9) write(x/10),x%=10;
    putchar(x+'0');
}
namespace test {
    struct qwq {
        int val[8];
        int ql=0,qr=0;
        inline void pb(int x) {
            val[(++qr)&7]=x;
        }
        inline void pf(int x) {
            ql=ql+7;
            val[ql&7]=x;
        }
        inline int frt(void) {
            return val[ql];
        }
        inline int back(void) {
            return val[qr];
        }
        inline void popb(void) {
            qr+=7;
        }
        inline void popf(void) {
            ql+=7;
        }
    }
    qwq S[500];
    inline void push(int x,int i) {
        if(i==q[x].front)q[x].
    }
}
signed main() {
    return 0;
}